package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolDetailBo;
import org.dromara.art.domain.vo.ArtSchoolDetailVo;
import org.dromara.art.domain.ArtSchoolDetail;
import org.dromara.art.mapper.ArtSchoolDetailMapper;
import org.dromara.art.service.IArtSchoolDetailService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校详细信息Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolDetailServiceImpl implements IArtSchoolDetailService {

    private final ArtSchoolDetailMapper baseMapper;

    /**
     * 查询学校详细信息
     *
     * @param detailId 主键
     * @return 学校详细信息
     */
    @Override
    public ArtSchoolDetailVo queryById(Long detailId){
        return baseMapper.selectVoById(detailId);
    }

    /**
     * 分页查询学校详细信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校详细信息分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolDetailVo> queryPageList(ArtSchoolDetailBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolDetail> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolDetailVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校详细信息列表
     *
     * @param bo 查询条件
     * @return 学校详细信息列表
     */
    @Override
    public List<ArtSchoolDetailVo> queryList(ArtSchoolDetailBo bo) {
        LambdaQueryWrapper<ArtSchoolDetail> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolDetail> buildQueryWrapper(ArtSchoolDetailBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolDetail> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolDetail::getDetailId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolDetail::getSchoolId, bo.getSchoolId());
        lqw.eq(StringUtils.isNotBlank(bo.getIntroduction()), ArtSchoolDetail::getIntroduction, bo.getIntroduction());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), ArtSchoolDetail::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getContact()), ArtSchoolDetail::getContact, bo.getContact());
        lqw.eq(StringUtils.isNotBlank(bo.getEmail()), ArtSchoolDetail::getEmail, bo.getEmail());
        lqw.eq(StringUtils.isNotBlank(bo.getWebsite()), ArtSchoolDetail::getWebsite, bo.getWebsite());
        return lqw;
    }

    /**
     * 新增学校详细信息
     *
     * @param bo 学校详细信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolDetailBo bo) {
        ArtSchoolDetail add = MapstructUtils.convert(bo, ArtSchoolDetail.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setDetailId(add.getDetailId());
        }
        return flag;
    }

    /**
     * 修改学校详细信息
     *
     * @param bo 学校详细信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolDetailBo bo) {
        ArtSchoolDetail update = MapstructUtils.convert(bo, ArtSchoolDetail.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolDetail entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校详细信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
